// constants won't change. They're used here to set pin numbers:
#include <Adafruit_MPU6050.h>
#include <Adafruit_Sensor.h>
#include <Wire.h>

Adafruit_MPU6050 mpu;

const int buttonPin =  4;     // the number of the pushbutton pin

const int ledPin        = 13;      // the number of the LED pin
const int ledPin1      = 12;
const int ledPin2      = 11;
const int LDRpin = 0;
const int soundPin=A1;

// variables will change:
int LDRValue = 0;     // result of reading the analog pin
int  initial    = 1;       //hold current  initial
int oldstate    = 0;       //hold last  initial
int buttonstate = 0;      // variable for reading the pushbutton status

void setup() {
  pinMode(ledPin, OUTPUT);   // initialize the LED pin as an output:
  pinMode(ledPin1, OUTPUT);
  pinMode(ledPin2, OUTPUT);
  pinMode(buttonPin, INPUT); // initialize the pushbutton pin as an input:
  Serial.begin(9600); // sets serial port for communication
   // Try to initialize!
  if (!mpu.begin()) {
    Serial.println("Failed to find MPU6050 chip");
    while (1) {
      delay(10);
    }    
}

  mpu.setAccelerometerRange(MPU6050_RANGE_8_G);
  mpu.setGyroRange(MPU6050_RANGE_500_DEG);
  mpu.setFilterBandwidth(MPU6050_BAND_5_HZ);
 
}
void loop(){
  sensors_event_t a, g, temp;
  mpu.getEvent(&a, &g, &temp);
  
 long sum = 0;
  for(int i=0; i<100; i++)
  {
     sum += analogRead(soundPin);
  }

  sum = sum/100;

  //Serial.println(sum);
  //Serial.println((String)"Sound = "+sum); 

    
  LDRValue = analogRead(LDRpin); // read the value from the LDR
  //Serial.println(LDRValue);      // print the value to the serial port
  //Serial.println((String)"Light = "+LDRValue); 

  //debouncing routline to read button
  buttonstate = digitalRead(buttonPin);  //state the  initial of button
  if(buttonstate == HIGH){               //check if it has been pressed 
    delay(50);
    buttonstate = digitalRead(buttonPin);//state button again
    if(buttonstate == LOW){   
      if(initial == 3) {
        initial = 1;
      }        
      else{  //if it is 0 considered one press
     initial = oldstate + 1;   
     }     //increase  initial by 1
    }
  }else{                          //check if it has been NOT pressed
      delay(100);
      }
   switch (initial){               //react to button press a  initial
     case 1:                     //if  initial is 1
       digitalWrite(ledPin, HIGH);//on
       digitalWrite(ledPin1, LOW);//off
       digitalWrite(ledPin2, LOW);//off
       oldstate =  initial;               //set oldstate  initial as current  initial
       break;
     case 2:
       digitalWrite(ledPin, LOW);
       digitalWrite(ledPin1, HIGH);
       digitalWrite(ledPin2, LOW);
       oldstate =  initial;
       break;
     case 3:
       digitalWrite(ledPin, LOW);
       digitalWrite(ledPin1, LOW);
       digitalWrite(ledPin2, HIGH);
       oldstate =  initial;
       break;         
     default:                      //if  initial is not 1 2 3
       digitalWrite(ledPin, LOW);  //off
       digitalWrite(ledPin1, LOW);
       digitalWrite(ledPin2, LOW);
       oldstate = 0;                    //reset to all off/initial 0
       break;    
     }
//string to send serial port data to unity
     Serial.println((String) "S:" + sum + ":S" + " L:" + LDRValue + ":L" + " B:" + initial + ":B" + " RX:" + g.gyro.x + ":RX" + " RY:" + g.gyro.y + ":RY" + " RZ:" + g.gyro.z + ":RZ" + " AX:" + a.acceleration.x + ":AX" + " AY:" + a.acceleration.y + ":AY");      
}

